/*
niced - daemon controlant automatiquement les priorites des processus

INSPIRE DE : (COPIE DE)
Maitrise des algorithmes en C
-- Kyle Loudon -- page 65

lou@bocal.cs.univ-paris8.fr
juin 2005

*/
#include <stdlib.h>
#include <string.h>
#include "list.h"

/*list_init*/
void list_init(List *liste, void (*detruire)(void * donnee)){

  liste->taille   = 0;
  liste->detruire = detruire;
  liste->tete     = NULL;
  liste->queue    = NULL;

return;
}

/*list_destroy*/
void list_destroy(List *liste){
  void * donnee;
  while(list_size(liste)>0){
    if(list_rem_next(liste,NULL,(void **)&donnee) == 0 && liste->detruire!=NULL){

      liste->detruire(donnee);
    }
}
  /*NETTOYER LA STRUCTURE PAR PRECAUTION*/
  memset(liste,0,sizeof(liste));
return;
}

int list_ins_next(List *liste,ListElmt *element, const void * donnee){
  ListElmt *nouv_element;
  if((nouv_element = (ListElmt *) malloc(sizeof(ListElmt))) == NULL)
    return -1;
  /*INSERTION*/
  nouv_element->donnee=(void *)donnee;
  if(element == NULL ){

    /*INSERTION EN TETE*/
    if(list_size(liste)==0)
      liste->queue = nouv_element;

    (nouv_element)->suivant=(ListElmt *)(liste->tete);
    liste->tete=nouv_element;

  }

  else {
  /*INSERTION AILLEURS*/

    if(element->suivant == NULL)
      liste->queue = nouv_element;

    nouv_element->suivant = element->suivant;
    (element->suivant)=(nouv_element);
  }
  liste->taille++;

  return 0;
}

int list_rem_next(List *liste,ListElmt *element,void ** donnee){
  ListElmt *ancien_element;
  if((list_size(liste))==0)
    return -1;
  if (element == NULL){/*Suppression de la tete*/
    *donnee = liste->tete->donnee;
    ancien_element = liste->tete;
    liste->tete = ((liste->tete)->suivant);

    if(list_size(liste) == 1)
      liste->queue = NULL;
  }
  else {
    /*Suppression ailleurs qu'en tete*/
    if(element->suivant == NULL)
      return -1;
    *donnee = element->suivant->donnee;
    ancien_element = element->suivant;
    element->suivant = element->suivant->suivant;

    if (element->suivant == NULL)
      liste->queue = element;
  }
  free(ancien_element);
  liste->taille--;

  return 0;
}
