#ifndef LIST__H
#define LIST__H

#include <stdlib.h>

typedef struct ListElmt_{
  void *donnee;
  struct ListElmt_ *suivant;
} ListElmt;

typedef struct list_ {
  int taille;
  void (*detruire)(void *donnee);
  int (*corresp)(const void *cle1, const void *cle2);
  ListElmt *tete;
  ListElmt *queue;
} List;

#define list_size(liste) ((liste)->taille)
#define list_head(liste) ((liste)->tete)
#define list_tail(liste) ((liste)->queue)
#define list_data(element) ((element)->donnee)
#define list_next(element) ((element)->suivant)

#define list_is_head(liste,element) ((element) == (liste)->tete ? 1 : 0) 
#define list_is_tail(element) ((element)->suivant == NULL ? 1 : 0)

void list_init(List *liste, void (*detruire) (void * donnee));
void list_destroy(List *liste);
int list_ins_next(List *liste,ListElmt *element, const void *donnee);
int list_rem_next(List *liste,ListElmt *element, void **donnee);

#endif
