#ifndef PROCESS_STAT__H
#define PROCESS_STAT__H
#include <dirent.h>              // dirent et scandir
#include <sys/resource.h>        // setprio>
#include "list.h"
/*****************************************************************/

/* Taille des buffers de lecture: 4 lignes */
#define BLEN 4*80
#define MAX_CAR_NOM 80
#define ROOT_GID 0
#define DIR_PROCESS "/proc"
#define MISE_AU_POINT 1
#define PS(elt) ((struct process_stat *)list_data(elt))
/* Jiffies: Unité de temps définie dans le page de manuel 'proc' */
#define JIFFIES_PER_SEC 100.
/*****************************************************************/

typedef unsigned long ulng;
struct process_stat {
  int   pid;
  char  tcomm[MAX_CAR_NOM];
  char  state;
  int   ppid;
  int   pgid;
  int   sid;
  int   tty_nr;
  int   tty_pgrp;
  ulng  task_flags;
  ulng  min_flt;
  ulng  cmin_flt;
  ulng  maj_flt;
  ulng  cmaj_flt;
  int  utime;
  int  stime;
  int  cutime;
  int  cstime;
};

extern void (*envoyer_message)(int,const char *,...);
extern void changer_priorites(List *,double,List *,pid_t,gid_t);
extern void remplir_liste_proc(List *,pid_t );
extern struct process_stat * process_stat(int);

#endif
/***************************************************************/
